#region Copyright Syncfusion Inc. 2001 - 2005
//
//  Copyright Syncfusion Inc. 2001 - 2005. All rights reserved.
//
//  Use of this code is subject to the terms of our license.
//  A copy of the current license can be obtained at any time by e-mailing
//  licensing@syncfusion.com. Any infringement will be prosecuted under
//  applicable laws. 
//
#endregion

using System;
using System.Drawing;
using System.Drawing.Imaging;
using System.Collections;
using System.ComponentModel;
using System.Windows.Forms;
using System.Data;
using System.IO;
using System.Diagnostics;

using Syncfusion.DLS;
using Syncfusion.DocIO;
using Syncfusion.DocIO.DLS;

namespace EssentialDocIOSamples
{
	/// <summary>
	/// Summary description for Form1.
	/// </summary>
	public class Form1 : System.Windows.Forms.Form
	{
		private System.Windows.Forms.Button button1;
		private System.Windows.Forms.Label label1;
		
		/// <summary>
		/// Required designer variable.
		/// </summary>
		private System.ComponentModel.Container components = null;

		public Form1()
		{
			//
			// Required for Windows Form Designer support
			//
			InitializeComponent();
			//
			// TODO: Add any constructor code after InitializeComponent call
			//
		}

		/// <summary>
		/// Clean up any resources being used.
		/// </summary>
		protected override void Dispose( bool disposing )
		{
			if( disposing )
			{
				if (components != null) 
				{
					components.Dispose();
				}
			}
			base.Dispose( disposing );
		}

		#region Windows Form Designer generated code
		/// <summary>
		/// Required method for Designer support - do not modify
		/// the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent()
		{
			System.Resources.ResourceManager resources = new System.Resources.ResourceManager(typeof(Form1));
			this.button1 = new System.Windows.Forms.Button();
			this.label1 = new System.Windows.Forms.Label();
			this.SuspendLayout();
			// 
			// button1
			// 
			this.button1.Anchor = (System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Right);
			this.button1.FlatStyle = System.Windows.Forms.FlatStyle.Flat;
			this.button1.Image = ((System.Drawing.Bitmap)(resources.GetObject("button1.Image")));
			this.button1.ImageAlign = System.Drawing.ContentAlignment.MiddleRight;
			this.button1.Location = new System.Drawing.Point(464, 72);
			this.button1.Name = "button1";
			this.button1.TabIndex = 0;
			this.button1.Text = "DOC";
			this.button1.Click += new System.EventHandler(this.button1_Click);
			// 
			// label1
			// 
			this.label1.Anchor = ((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Left) 
				| System.Windows.Forms.AnchorStyles.Right);
			this.label1.Font = new System.Drawing.Font("Verdana", 8.25F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((System.Byte)(0)));
			this.label1.Name = "label1";
			this.label1.Size = new System.Drawing.Size(544, 56);
			this.label1.TabIndex = 1;
			this.label1.Text = @"Clicking the button below will result in a new MS Word document being generated using Essential DocIO.  At the end of the document generation, an option will be provided to view the generated MS Word file. Please note that you need to have an MS Word file viewer installed in order to view the generated Word file.";
			// 
			// Form1
			// 
			this.AutoScaleBaseSize = new System.Drawing.Size(5, 13);
			this.ClientSize = new System.Drawing.Size(544, 102);
			this.Controls.AddRange(new System.Windows.Forms.Control[] {
																		  this.label1,
																		  this.button1});
			this.FormBorderStyle = System.Windows.Forms.FormBorderStyle.FixedSingle;
			this.Icon = ((System.Drawing.Icon)(resources.GetObject("$this.Icon")));
			this.MaximizeBox = false;
			this.Name = "Form1";
			this.Text = "Essential DocIO Sample";
			this.ResumeLayout(false);

		}
		#endregion

		/// <summary>
		/// The main entry point for the application.
		/// </summary>
		[STAThread]
		static void Main() 
		{
			Application.Run(new Form1());			
		}

		private void button1_Click(object sender, System.EventArgs e)
		{
			// Creating a new document.
			WordDocument document = new WordDocument();

			// Open an existing template document.
			document.Open ( @"..\..\Data\Test.doc" , FormatType.Doc );			

			// Create Paragraph styles
			IParagraphStyle style = document.AddParagraphStyle ( "MyStyle_Normal" );
			style.CharacterFormat.FontName = "Bitstream Vera Serif";
			style.CharacterFormat.FontSize = 10f;
			style.ParagraphFormat.HorizontalAlignment = Syncfusion.DLS.HorizontalAlignment.Justify;
			style.CharacterFormat.TextColor  = Color.FromArgb ( 0 , 21 , 84 );

			style = document.AddParagraphStyle ( "MyStyle_Low" );
			style.CharacterFormat.FontName = "Times New Roman";
			style.CharacterFormat.FontSize = 16f;
			style.CharacterFormat.Bold = true;
			
			style = document.AddParagraphStyle ( "MyStyle_Medium" );
			style.CharacterFormat.FontName = "Monotype Corsiva";
			style.CharacterFormat.FontSize = 18f;
			style.CharacterFormat.Bold = true;			
			style.CharacterFormat.TextColor = Color.FromArgb ( 51 , 66 , 125 );

			style = document.AddParagraphStyle ( "Mystyle_High" );
			style.CharacterFormat.FontName = "Bitstream Vera Serif";			
			style.CharacterFormat.FontSize = 20f;
			style.CharacterFormat.Bold = true;	
			style.CharacterFormat.TextColor  = Color.FromArgb ( 242 , 151 , 50 );
			style.ParagraphFormat.HorizontalAlignment = Syncfusion.DLS.HorizontalAlignment.Center;

			// Adding a new section to the document.
			IWSection section = document.LastSection;
			IWParagraph paragraph = null;
			for ( int i = 1 ; i < document.Styles.Count ; i++ )
			{
				// Getting styles from Document.
				style = (IParagraphStyle ) document.Styles [ i ];
				// Adding a new paragraph
				section.AddParagraph();
				paragraph = section.AddParagraph();
				// Applying styles to the current paragraph.
				paragraph.ApplyStyle ( style.Name );
				// Writing Text with the current style and formatting.
				paragraph.AppendText ( "Syncfusion Inc [" + style.Name + "] Style");
				// Adding a new paragraph
				section.AddParagraph();
				paragraph = section.AddParagraph();				
				// Applying another style to the current paragraph.
				paragraph.ApplyStyle("MyStyle_Normal");
				// Writing text with current style.
				paragraph.AppendText ( "We are a leading provider of software components and tools for the Microsoft .NET platform. Powerful and feature-rich, Syncfusions broad range of products are vital to mission-critical applications in organizations ranging from small businesses to multinational Fortune 100 companies. ");                
				Console.WriteLine ( style.Name );
			}

			// Saving created document to disk.
			document.Save ( "Sample.doc" , FormatType.Doc );
			
			// Message box confirmation to view the created document.
			if( MessageBox.Show( "Do you want to view the MS Word document?" , "Document has been created" , MessageBoxButtons.YesNo, MessageBoxIcon.Information ) == DialogResult.Yes ) 
			{
				// Launching the MS Word file using the default Application.[MS Word Or Free WordViewer]
				Process.Start ( @"..\..\Data\Test.doc" );
				Process.Start ( "Sample.doc" );
				// Exit
				this.Close();
			}
			else
			{
				// Exit
				this.Close();
			}
			
		}		
	}
}
